#ifdef	HTTP_DECODED_URL_SIZE
#define	LOG_URL_SIZE		HTTP_DECODED_URL_SIZE
#else
#define	LOG_URL_SIZE		1024*2
#endif

#define	LOG_FILENAME_LEN	1024
#define	LOG_RECORD_LEN		1024*4


#define	LOG_OPEN_FLAG_NONE	0x000
#define	LOG_OPEN_FLAG_ACCESS	0x001
#define	LOG_OPEN_FLAG_ERROR	0x002

#ifndef	_SYS_SYSLOG_H
#define	LOG_EMERG		0	/* system is unusable */
#define	LOG_ALERT		1	/* action must be taken immediately */
#define	LOG_CRIT		2	/* critical conditions */
#define	LOG_ERR			3	/* error conditions */
#define	LOG_WARNING		4	/* warning conditions */
#define	LOG_NOTICE		5	/* normal but significant condition */
#define	LOG_INFO		6	/* informational */
#define	LOG_DEBUG		7	/* debug-level messages */
#endif


struct log_record_t {
	struct log_record_t	*next;				//α Ʈ  

	time_t			time;				//α ڵ ð
	short			priority;

	char			*msg;

	struct in_addr		client_addr;

	struct vhost_t		*request_vhost;
	char			*request_referer;
	char			*request_url;
	short			request_method;

	short			response_status;
	int			response_content_length;
};

struct logfile_t {
	pthread_mutex_t		mutex;

	short			is_default;

	struct log_record_t	*log_list_start;
	struct log_record_t	*log_list_end;
	int			log_list_size;

	struct vhost_t		*vhost;

	time_t			time;				//α   ð. ̼ .

	char			log_filename_access[LOG_FILENAME_LEN];
	char			log_filename_error[LOG_FILENAME_LEN];

	short			log_open_flag;
	FILE			*log_access;
	FILE			*log_error;
};

struct log_t {
	char			*path;
	short			rotate;
	int			rotate_cycle;
	short			vhost_log_split;

	struct logfile_t	*logfile;
	int			logfile_len;

	pthread_t		thread;
	pthread_mutex_t		mutex;
};



void tlog_record( short priority, char *msg, struct vhost_t *vhost, struct http_request_header_t *request_header, struct http_response_header_t *response_header );
void tlog_record_append( struct logfile_t *logfile, struct log_record_t *record );

void tlog_init();
void *tlog_proc(void *data);
void tlog_write_logfile( struct logfile_t *logfile, struct tm *now );
short tlog_open_logfiles( struct tm *now );
short tlog_open_logfile( struct logfile_t *logfile, struct tm *now );
void tlog_close_logfile( struct logfile_t *logfile );


